<?php

namespace App\Service;

use App\Service\Rules\AbstractRule;
use App\Service\Rules\PlayTimeRule;
use App\Service\Rules\TimeRule;

class RuleChecker
{
    public function __construct(
        private readonly TimeRule     $timeRule,
        private readonly PlayTimeRule $playTimeRule,
    ) {}

    /**
     * @return AbstractRule[]
     */
    public function getRules(): array
    {
        // Order is very important!
        return [
            $this->timeRule,
            $this->playTimeRule,
        ];
    }
}