<?php

namespace App\Service\Rules;

class RuleResult
{
    public function __construct(
        private readonly RuleResultEnum $state,
        private readonly string         $message = '',
    ) {}

    public function __toString(): string
    {
        $message = $this->state->getString();
        if ($this->message !== '') {
            $message .= ': ' . $this->message;
        }
        return $message;
    }

    public function isAllowed(): bool
    {
        return $this->state !== RuleResultEnum::DENIED;
    }

    public function isWarning(): bool
    {
        return $this->state === RuleResultEnum::WARNING;
    }

    public function getMessage(): string
    {
        return $this->message;
    }
}